# MemoRekall Member Web App 

An online video annotation app.

This project has been created to help artists documenting their creative process with video notes and documents.

## License

This project is distributed under the CeCILL-B Open Source License :

http://www.cecill.info/licences/Licence_CeCILL_V2.1-en.html

http://www.cecill.info/licences/Licence_CeCILL_V2.1-fr.html

The licence in french and english are included in the Git repo under the `license` folder.

## Installation

Copy the file `.env_default` to `.env` and adapt it to your needs

Run the following commands

```bash
git clone https://gitlab.tetras-libre.fr/rekall/memorekall-member-new
cd memorekall-member-new
# Build and start the containers
docker-compose up --build
# In another terminal
docker-compose exec memorekall-member php bin/console doctrine:schema:create
```

### Developpement only

To configure the automated test, see [the dedicated wiki page](https://gitlab.tetras-libre.fr/rekall/memorekall-member-new/-/wikis/Tests)

## Contributors
The Tetras Libre team follows some code quality requirements. 
Indeed, to ensure the respect of the standards PHP and JavaScript rules, we use a pre-commit hook as a safety net before sending any contribution.
The following quality tool scripts will be triggered before reaching commit message editor.
- **PHPUnit** (functional and unit tests)
- **PHP_CodeSniffer** (for PSR standards)
- **PHPSTAN** (for static analysis)
- **ESLint** (JavaScript linter)
***

### How to run the code quality scripts?
First, you need to enter the memorekall-member docker container: `docker-compose exec memorekall-member bash`
- To run the script independently of a commit: `composer {phpcs/phpstan/tests}` or `npm install` and `npm run lint` for ESLint
- To fix PHP_CodeSniffer errors: `composer phpcbf`
- To run unit tests `composer tests`
- To run them all: `composer ci`

### How to contribute to the MemoRekall project? 
Please configure your local git as follows:
1. From your terminal, run: `git config core.hooksPath ./tools/git-hooks/`
2. Make the pre-commit hook executable running: `sudo chmod +x ./tools/git-hooks/pre-commit`
