((app) => {
    function RekallApplication(opts = {}) {
        const METHODS = [
            'openUrl',
            'pubSub',
            'init',
            'setPlaybackRate',
            'videoPlayer',
            'rekall',
            'getUrl',
            'projectName',
            'mosaicWidget'
        ];

        let localOptions = {};

        const OPTIONS = {
            getUrl: function (){
                if (arguments && localOptions.links && localOptions.links[arguments[0]]) {
                    return localOptions.links[arguments[0]];
                }
                return '';
            },
            init: function (opts) {
                if (opts) {
                    $.extend(localOptions, opts);
                }
            },
            mosaicWidget : function (){
                if (!arguments.length){
                    return localOptions.MosaicWidget;
                }
                if ('object' === typeof arguments[0] && null !== arguments[0]) {
                    localOptions.MosaicWidget = arguments[0];
                }
            },
            openUrl: function () {
                if (!arguments)
                    return;
                if (localOptions.links && localOptions.links[arguments[0]]) {
                    window.top.location.assign(localOptions.links[arguments[0]])
                } else {
                    window.top.location.assign(arguments[0]);
                }
            },
            projectName: function(){
                if (0 === arguments.length) {
                    if (localOptions?.Rekall?.project?.metadata) {
                        return localOptions.Rekall.project.metadata["Title"];
                    }

                    return "";
                }
                else if ('string' === typeof arguments[0]) {
                    if (!localOptions?.Rekall?.project?.metadata["Title"]){
                        localOptions.Rekall.project.metadata["Title"] = '';
                    }

                    if(localOptions.Rekall.project.metadata["Title"] !== arguments[0])
                    {
                        localOptions.Rekall.project.metadata["Title"] = arguments[0];
                        localOptions.PubSub.publish('updated.project.name', { projectName: localOptions.Rekall.project.metadata["Title"] })
                    }
                }
            },
            pubSub: function () {
                return localOptions.PubSub;
            },
            rekall: function () {
              return localOptions.Rekall;
            },
            setPlaybackRate: function () {
                if (arguments.length > 0 && 'number' === typeof arguments[0] && 0 < arguments[0] && arguments[0] < 10) {
                    localOptions.videoPlayer.playbackRate(arguments[0]);
                }
            },
            videoPlayer: function () {
                if (arguments.length > 0) {
                    localOptions._videoPlayer = arguments[0];
                }

                return localOptions._videoPlayer;
            }
        };

        $.extend(localOptions, OPTIONS, opts);

        return {
            Rekall: function () {
                if (!arguments || !arguments.length)
                    return localOptions['rekall'].apply(this, arguments);

                let [action, ...params] = arguments;
                if (METHODS.includes(action)) {
                    return localOptions[action].apply(this, params);
                }
            }
        }
    }
    app.rekall = new RekallApplication();
})(window.app = window.app || {})
